<template>
    <form @submit.prevent>
        <div class="form__header">
            <h1 class="form__title">Create account</h1>
            <h2 class="form__clue">
                Already have an account?
                <router-link to="/">Log in here</router-link>
            </h2>
        </div>

        <div class="form__body">
            <div class="form__input">
                <AhInput
                    label="Username"
                    placeholder="Enter your username"
                    v-model="formData.username"
                    :error="v$.formData?.username?.$error"
                    clearable
                />
                <HelpText class="form__help-text" v-show="v$.formData?.username?.$error" :error="v$.formData?.username?.$error">
                    {{ v$.formData?.username?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__input">
                <AhInput
                    label="Email"
                    placeholder="Enter your email"
                    v-model="formData.email"
                    :error="v$.formData?.email?.$error"
                    clearable
                />
                <HelpText class="form__help-text" v-show="v$.formData?.email?.$error" :error="v$.formData?.email?.$error">
                    {{ v$.formData?.email?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__input">
                <AhInput
                    label="Password"
                    type="password"
                    placeholder="Enter your password"
                    v-model="formData.password"
                    v-model:is-visible="isPasswordVisible"
                    :error="v$.formData?.password?.$error"
                    visibility-control
                    clearable
                />
                <div class="input__hints form__help-text" v-if="formData.password">
                    <div class="input__hint" v-for="([key, value]) in passwordChips" :key="key">
                        <img v-if="!value.$invalid" src="@/assets/icons/green-check.svg" alt="">
                        <img v-else src="@/assets/icons/red-cross.svg" alt="">
                        <span>{{ value.$message }}</span>
                    </div>
                </div>
                <HelpText class="form__help-text" v-else-if="v$.formData?.password?.$error" :error="v$.formData?.password?.$error">
                    {{ v$.formData?.password?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__input">
                <AhInput
                    label="Password confirmation"
                    type="password"
                    placeholder="Confirm your password"
                    v-model.trim="formData.passwordConfirmation"
                    v-model:is-visible="isPasswordConfirmationVisible"
                    :error="v$.formData?.passwordConfirmation?.$error"
                    visibility-control
                    clearable
                />
                <HelpText class="form__help-text"
                          v-show="v$.formData?.passwordConfirmation?.$error"
                          :error="v$.formData?.passwordConfirmation?.$error">
                    {{ v$.formData?.passwordConfirmation?.$errors[0]?.$message }}
                </HelpText>
            </div>
            <div class="form__input">
                <AhInput
                    v-model="formData.referralId"
                    label="Referal ID"
                    placeholder="Enter your referal id (Optional)"
                />
            </div>
            <div class="form__checkbox">
                <AhCheckbox :disabled="false" v-model="formData.termsOfUse"
                                :error="v$.formData?.termsOfUse?.$error">
                  <span class="checkbox__text">
                    Я согласен(а) с Altcoins Hub <router-link to="">Условия использования</router-link>
                    и <router-link to="">Политикой конфиденциальности.</router-link>
                  </span>
                </AhCheckbox>
            </div>

            <div class="form__checkbox">
                <AhCheckbox
                    v-model="formData.termsOfNationality"
                    :disabled="false"
                    :error="v$.formData?.termsOfNationality?.$error"
                >
                    <div class="checkbox__text">
                        Я подтверждаю, что я не являюсь гражданином и/или резидентом следующих стран: Афганистан,
                        Американское Самоа, Виргинские острова США, территория Гуам, Иран, Ирак, Йемен, Ливия,
                        Пакистан, Государство Палестина, Пуэрто-Рико, Сомали, Корейская Народно-Демократическая
                        Республика,
                        Северные Марианские острова, США, Сирия, Республика Судан, Приднестровье, Абхазия, Южная Осетия,
                        Карабах,
                        Турецкая Республика Северного Кипра, Западная Сахара, Федеративная Республика Амбазония,
                        Косово и временно оккупированные территории Украины.
                    </div>
                </AhCheckbox>
            </div>
        </div>
        <div class="form__buttons">
            <AhButton @click="submitForm" class="form__button">Continue</AhButton>
        </div>
    </form>
</template>

<script>

import AhInput from "@/components/AhInput";
import AhButton from "@/components/AhButton";
import AhCheckbox from "@/components/AhCheckbox";
import useVuelidate from '@vuelidate/core'
import {required, email, sameAs, helpers, minLength } from '@vuelidate/validators'
import HelpText from "@/components/HelpText";
import { containsNumber, containsUpperCase, containsSymbol } from "@/validators";

export default {
    name: "LoginPage",
    components: {HelpText, AhCheckbox, AhInput, AhButton},
    setup() {
        return {
            v$: useVuelidate()
        }
    },
    data() {
      return {
          formData: {
              termsOfUse: false,
              termsOfNationality: false,
              username: null,
              email: null,
              password: null,
              passwordConfirmation: null,
              referralId: null,
          },
          isPasswordVisible: false,
          isPasswordConfirmationVisible: false
      }
    },
    validations() {
        return {
            formData: {
                username: {
                    required: helpers.withMessage('Please enter your username', required)
                },
                email: {
                    required: helpers.withMessage('Please enter your email', required),
                    email: helpers.withMessage('Email format is not valid', email),
                },
                password: {
                    required: helpers.withMessage('Please enter your password', required),
                    minLength: helpers.withMessage('Minimum 8 characters', minLength(8)),
                    mustContainAtLeastOneNumber: helpers.withMessage('At least 1 number', containsNumber),
                    mustContainAtLeastOneSymbol: helpers.withMessage('At least 1 symbol', containsSymbol),
                    mustContainAtLeastOneUpperCase: helpers.withMessage('At least 1 upper case', containsUpperCase),
                },
                passwordConfirmation: {
                    sameAs: helpers.withMessage('Password confirmation must match with password', sameAs(this.formData.password))
                },
                termsOfUse: {sameAs: sameAs(true)},
                termsOfNationality: {sameAs: sameAs(true)},
            }
        }
    },
    methods: {
        async submitForm() {
            const isFormCorrect = await this.v$.$validate();
            if (!isFormCorrect) {
                return;
            }
            // @TODO Implement geetest captcha
            this.$router.push({ name: 'email-verification' });
        },
    },
    computed: {
        passwordChips() {
            return Object.entries(this.v$.formData?.password).filter(([key]) => !key.startsWith('$') && key !== 'required');
        }
    }
}

</script>

<style lang="scss" scoped>

form {
    max-width: 400px;
    display: flex;
    flex-direction: column;
    justify-items: center;
}

.form__title {
    font-family: 'Lato', sans-serif;
    font-style: normal;
    font-weight: 700;
    font-size: 50px;
    line-height: 60px;
    margin-bottom: 0;

    color: #FFFFFF;
}

.form__clue {
    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 500;
    font-size: 16px;
    line-height: 140%;
    margin: 11px 0 20px 0;

    color: #FFFFFF;
}

.form__clue a, .form__checkbox a {
    color: $hsl-color-orange;
}

.form__header {
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
}

.form__input {
    padding-bottom: 24px;
    position: relative;
}

.form__help-text {
    position: absolute;
}

.form__checkbox:not(:last-child) {
    margin-bottom: 13px;
}

.checkbox__text {
    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 15px;
    color: #818694;
}

.input__hints {
    display: flex;
    justify-content: left;
    margin-left: 4px;
}

.input__hint {
    margin-right: 7px;
    display: flex;
    width: fit-content;
    background: #FFD700;
    border-radius: 2px;
    padding: 3px 3px 3px 5px;

    span {
        font-family: 'Arial', sans-serif;
        font-style: normal;
        font-weight: 400;
        font-size: 8px;
        line-height: 9px;
        margin-left: 2px;
        color: #000000;
    }
}

.form__buttons {
    margin-top: 18px;
}

</style>